/* 
 *   $Id: ad_nfs_fcntl.c,v 1.3 1997/09/04 20:11:32 thakur Exp $    
 *
 *   Copyright (C) 1997 University of Chicago. 
 *   See COPYRIGHT notice in top-level directory.
 */

#include "ad_nfs.h"

void ADIOI_NFS_Fcntl(ADIO_File fd, int flag, ADIO_Fcntl_t *fcntl_struct, int *error_code)
{
    if (flag == ADIO_FCNTL_SET_IOMODE) {
	if (fd->iomode != fcntl_struct->iomode) {
	    fd->iomode = fcntl_struct->iomode;
	    MPI_Barrier(MPI_COMM_WORLD);
	}
    }

    if (flag == ADIO_FCNTL_SET_ATOMICITY)
	fd->atomicity = (fcntl_struct->atomicity == 0) ? 0 : 1;

    if (flag == ADIO_FCNTL_GET_FSIZE) {
	ADIOI_READ_LOCK(fd->fd_sys, 0, SEEK_SET, 1);
	fcntl_struct->fsize = lseek(fd->fd_sys, 0, SEEK_END);
	ADIOI_UNLOCK(fd->fd_sys, 0, SEEK_SET, 1);
	if (fd->fp_sys_posn != -1) 
	    lseek(fd->fd_sys, fd->fp_sys_posn, SEEK_SET);
    }

    *error_code = MPI_SUCCESS;
}
