/* 
 *   $Id: ad_ufs_fcntl.c,v 1.2 1997/09/04 20:49:39 thakur Exp $    
 *
 *   Copyright (C) 1997 University of Chicago. 
 *   See COPYRIGHT notice in top-level directory.
 */

#include "ad_unix.h"

void ADIOI_UFS_Fcntl(ADIO_File fd, int flag, ADIO_Fcntl_t *fcntl_struct, int *error_code)
{
    if (flag == ADIO_FCNTL_SET_IOMODE) {
	if (fd->iomode != fcntl_struct->iomode) {
	    fd->iomode = fcntl_struct->iomode;
	    MPI_Barrier(MPI_COMM_WORLD);
	}
    }

    if (flag == ADIO_FCNTL_SET_ATOMICITY)
	fd->atomicity = (fcntl_struct->atomicity == 0) ? 0 : 1;

    *error_code = MPI_SUCCESS;
}
