/* 
 *   $Id: ad_open.c,v 1.2 1997/09/04 20:56:57 thakur Exp $    
 *
 *   Copyright (C) 1997 University of Chicago. 
 *   See COPYRIGHT notice in top-level directory.
 */

#include "adio.h"
#ifdef __MPICH
#include "mpich2.h"
#endif
#ifdef __MPISGI
#include "mpisgi2.h"
#endif

ADIO_File ADIO_Open(MPI_Comm comm, char *filename, int file_system,
		    int access_mode, ADIO_Offset disp, MPI_Datatype etype, 
		    MPI_Datatype filetype, int iomode,
                    ADIO_Hints hints, int perm, int *error_code)
{
    ADIO_File fd;
    MPI_Comm newcomm;

    fd = (ADIO_File) ADIOI_Malloc(sizeof(ADIOI_FileD));

    fd->cookie = ADIOI_FILE_COOKIE;
    fd->fp_ind = disp;
    fd->fp_sys_posn = 0;
    MPI_Comm_dup(comm, &newcomm);
    fd->comm = newcomm;
    fd->filename = strdup(filename);
    fd->file_system = file_system;
    fd->access_mode = access_mode;
    fd->disp = disp;
    fd->atomicity = 0;

    fd->etype = etype;          /* MPI_BYTE by default */
    fd->filetype = filetype;    /* MPI_BYTE by default */
    fd->etype_size = 1;  /* default etype is MPI_BYTE */

    fd->perm = perm;
    fd->hints = hints;
    fd->iomode = iomode;
    fd->async_count = 0;

/* set I/O function pointers */
    ADIOI_SetFunctions(fd);

    (*(fd->fns->ADIOI_xxx_Open))(fd, error_code);

    return fd;
}
