/* 
 *   $Id: delete.c,v 1.3 1997/09/28 17:29:59 thakur Exp $    
 *
 *   Copyright (C) 1997 University of Chicago. 
 *   See COPYRIGHT notice in top-level directory.
 */

#include "mpioimpl.h"

/*@
    MPI_File_delete - Deletes a file

Input Parameters:
. filename - name of file to delete (string)
. info - info object (handle)

.N fortran
@*/
int MPI_File_delete(char *filename, MPI_Info info)
{
    int error_code;

    if (!strncmp(filename, "pfs:", 4)) filename += 4;
    else if (!strncmp(filename, "piofs:", 6)) filename += 6;
    else if (!strncmp(filename, "ufs:", 4)) filename += 4;
    else if (!strncmp(filename, "nfs:", 4)) filename += 4;
    else {
        printf("MPI_File_delete: The filename must be prefixed with the type of file sytem; e.g., pfs:filename. Only PFS, PIOFS, UFS, and NFS files currently supported\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
    }

    ADIO_Delete(filename, &error_code);
    return error_code;
}
