/* 
 *   $Id: file_f2c.c,v 1.5 1997/09/05 17:35:48 thakur Exp $    
 *
 *   Copyright (C) 1997 University of Chicago. 
 *   See COPYRIGHT notice in top-level directory.
 */

#include "mpioimpl.h"
#include "adio_extern.h"

/*@
    MPI_File_f2c - Translates a Fortran file handle to a C file handle

Input Parameters:
. fh - Fortran file handle (integer)

Return Value:
. C file handle (handle)
@*/
MPI_File MPI_File_f2c(MPI_Fint fh)
{

#ifndef __INT_LT_POINTER
    return (MPI_File) fh;
#else
    if ((fh <= 0) || (fh >= ADIOI_Ftable_max)) return (MPI_File) fh;
    else return ADIOI_Ftable[fh];
#endif
}
