/* 
 *   $Id: deletef.c,v 1.6 1997/09/28 17:30:51 thakur Exp $    
 *
 *   Copyright (C) 1997 University of Chicago. 
 *   See COPYRIGHT notice in top-level directory.
 */

#include "mpio.h"

#ifdef __MPIO_BUILD_PROFILING
#ifdef FORTRANCAPS
#define mpi_file_delete_ PMPI_FILE_DELETE
#elif defined(FORTRANDOUBLEUNDERSCORE)
#define mpi_file_delete_ pmpi_file_delete__
#elif !defined(FORTRANUNDERSCORE)
#define mpi_file_delete_ pmpi_file_delete
#else
#define mpi_file_delete_ pmpi_file_delete_
#endif
#else
#ifdef FORTRANCAPS
#define mpi_file_delete_ MPI_FILE_DELETE
#elif defined(FORTRANDOUBLEUNDERSCORE)
#define mpi_file_delete_ mpi_file_delete__
#elif !defined(FORTRANUNDERSCORE)
#define mpi_file_delete_ mpi_file_delete
#endif
#endif

void mpi_file_delete_(char *filename,MPI_Info *info, int *__ierr, int str_len)
{
    char *newfname;
    int real_len, i;

    /* strip trailing blanks */
    if (!filename) {
        printf("MPI_File_delete: filename is a null pointer\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
    }
    for (i=str_len-1; i>=0; i--) if (filename[i] != ' ') break;
    if (i < 0) {
        printf("MPI_File_delete: filename is a blank string\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
    }
    real_len = i + 1;

    newfname = (char *) ADIOI_Malloc((real_len+1)*sizeof(char));
    strncpy(newfname, filename, real_len);
    newfname[real_len] = '\0';

    *__ierr = MPI_File_delete(newfname,*info);

    ADIOI_Free(newfname);
}
