/* 
 *   $Id: fsyncf.c,v 1.5 1997/10/01 08:00:15 thakur Exp $    
 *
 *   Copyright (C) 1997 University of Chicago. 
 *   See COPYRIGHT notice in top-level directory.
 */

#include "mpio.h"

#ifdef __MPIO_BUILD_PROFILING
#ifdef FORTRANCAPS
#define mpi_file_sync_ PMPI_FILE_SYNC
#elif defined(FORTRANDOUBLEUNDERSCORE)
#define mpi_file_sync_ pmpi_file_sync__
#elif !defined(FORTRANUNDERSCORE)
#define mpi_file_sync_ pmpi_file_sync
#else
#define mpi_file_sync_ pmpi_file_sync_
#endif
#else
#ifdef FORTRANCAPS
#define mpi_file_sync_ MPI_FILE_SYNC
#elif defined(FORTRANDOUBLEUNDERSCORE)
#define mpi_file_sync_ mpi_file_sync__
#elif !defined(FORTRANUNDERSCORE)
#define mpi_file_sync_ mpi_file_sync
#endif
#endif

#if defined(__cplusplus)
extern "C" {
#endif
void mpi_file_sync_(MPI_Fint *fh, int *__ierr )
{
    MPI_File fh_c;
    
    fh_c = MPI_File_f2c(*fh);
    *__ierr = MPI_File_sync(fh_c);
}
#if defined(__cplusplus)
}
#endif
