/* 
 *   $Id: get_viewf.c,v 1.5 1997/09/28 17:30:51 thakur Exp $    
 *
 *   Copyright (C) 1997 University of Chicago. 
 *   See COPYRIGHT notice in top-level directory.
 */

#include "mpio.h"

#ifdef __MPIO_BUILD_PROFILING
#ifdef FORTRANCAPS
#define mpi_file_get_view_ PMPI_FILE_GET_VIEW
#elif defined(FORTRANDOUBLEUNDERSCORE)
#define mpi_file_get_view_ pmpi_file_get_view__
#elif !defined(FORTRANUNDERSCORE)
#define mpi_file_get_view_ pmpi_file_get_view
#else
#define mpi_file_get_view_ pmpi_file_get_view_
#endif
#else
#ifdef FORTRANCAPS
#define mpi_file_get_view_ MPI_FILE_GET_VIEW
#elif defined(FORTRANDOUBLEUNDERSCORE)
#define mpi_file_get_view_ mpi_file_get_view__
#elif !defined(FORTRANUNDERSCORE)
#define mpi_file_get_view_ mpi_file_get_view
#endif
#endif


#ifdef __MPIHP
void mpi_file_get_view_(MPI_Fint *fh,MPI_Offset *disp,MPI_Fint *etype,
   MPI_Fint *filetype,char *datarep, int *__ierr, int str_len )
{
    MPI_File fh_c;
    MPI_Datatype etype_c, filetype_c;
    int i;

/* Initialize the string to all blanks */
    if (!datarep) {
        printf("MPI_File_get_view: datarep is a null pointer\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
    }
    for (i=0; i<str_len; i++) datarep[i] = ' ';
    
    fh_c = MPI_File_f2c(*fh);
    *__ierr = MPI_File_get_view(fh_c, disp, &etype_c, &filetype_c, datarep);

    *etype = MPI_Type_c2f(etype_c);
    *filetype = MPI_Type_c2f(filetype_c);
}

#else

void mpi_file_get_view_(MPI_Fint *fh,MPI_Offset *disp,MPI_Datatype *etype,
   MPI_Datatype *filetype,char *datarep, int *__ierr, int str_len )
{
    MPI_File fh_c;
    int i;

/* Initialize the string to all blanks */
    if (!datarep) {
        printf("MPI_File_get_view: datarep is a null pointer\n");
        MPI_Abort(MPI_COMM_WORLD, 1);
    }
    for (i=0; i<str_len; i++) datarep[i] = ' ';
    
    fh_c = MPI_File_f2c(*fh);
    *__ierr = MPI_File_get_view(fh_c, disp, etype, filetype, datarep);
}
#endif
