/* 
 *   $Id: set_sizef.c,v 1.5 1997/10/01 08:02:41 thakur Exp $    
 *
 *   Copyright (C) 1997 University of Chicago. 
 *   See COPYRIGHT notice in top-level directory.
 */

#include "mpio.h"

#ifdef __MPIO_BUILD_PROFILING
#ifdef FORTRANCAPS
#define mpi_file_set_size_ PMPI_FILE_SET_SIZE
#elif defined(FORTRANDOUBLEUNDERSCORE)
#define mpi_file_set_size_ pmpi_file_set_size__
#elif !defined(FORTRANUNDERSCORE)
#define mpi_file_set_size_ pmpi_file_set_size
#else
#define mpi_file_set_size_ pmpi_file_set_size_
#endif
#else
#ifdef FORTRANCAPS
#define mpi_file_set_size_ MPI_FILE_SET_SIZE
#elif defined(FORTRANDOUBLEUNDERSCORE)
#define mpi_file_set_size_ mpi_file_set_size__
#elif !defined(FORTRANUNDERSCORE)
#define mpi_file_set_size_ mpi_file_set_size
#endif
#endif

#if defined(__cplusplus)
extern "C" {
#endif
void mpi_file_set_size_(MPI_Fint *fh,MPI_Offset *size, int *__ierr )
{
    MPI_File fh_c;
    
    fh_c = MPI_File_f2c(*fh);
    *__ierr = MPI_File_set_size(fh_c,*size);
}
#if defined(__cplusplus)
}
#endif
